EDBFrame = CreateFrame("Frame", "EDBFrame")
local playername=(UnitName("PLAYER"));

EDB = {};
function EDBEvent(self, event, ...)
	if (event=="ADDON_LOADED") then
		local addon = ...;
		if (addon=="Blizzard_GuildUI") then
			EDB_CreateFrame();
			GuildRosterContainer:HookScript("OnUpdate", function() EDB_GuildFrameUpdated() end);
			EDBFrame:UnregisterEvent("ADDON_LOADED");
		end
	end
end

EDBFrame:SetScript("OnEvent", EDBEvent);
EDBFrame:RegisterEvent("ADDON_LOADED");
EDBFrame:RegisterEvent("CHAT_MSG_ADDON");

function EDB_CreateFrame()
	if (GuildMemberDetailFrame) then
		EDBFrame:SetParent(GuildMemberDetailFrame);
		EDBFrame:SetWidth(GuildMemberDetailFrame:GetWidth());
		EDBFrame:SetHeight(55);
		EDBFrame:SetPoint("TOPLEFT", GuildMemberDetailFrame, "BOTTOMLEFT", 0, 5);
		EDBFrame:SetBackdrop(GuildMemberDetailFrame:GetBackdrop());
		
		EDBMSText = EDBFrame:CreateFontString("EDBLabel", "ARTWORK", "GameFontNormal");
		EDBMSText:SetHeight(10);
		EDBMSText:SetPoint("TOPLEFT", EDBFrame, "TOPLEFT", 15, -15);
		EDBMSButton = CreateFrame("Button", nil, me)
		EDBMSButton:SetPoint("TOPLEFT", EDBFrame, "TOPLEFT", 15, -15);
		EDBMSButton:SetWidth(100)
		EDBMSButton:SetHeight(10);
		EDBMSButton:SetScript("OnClick", Elgoh_CycleMS);

		EDBOSText = EDBFrame:CreateFontString("EDBLabel", "ARTWORK", "GameFontNormal");
		EDBOSText:SetHeight(10);
		EDBOSText:SetPoint("TOPLEFT", EDBMSText, "BOTTOMLEFT", 0, -5);
		EDBOSButton = CreateFrame("Button", nil, me)
		EDBOSButton:SetPoint("TOPLEFT", EDBMSText, "BOTTOMLEFT", 0, -5);
		EDBOSButton:SetWidth(100)
		EDBOSButton:SetHeight(10)
		EDBOSButton:SetScript("OnClick", Elgoh_CycleOS);
		
		EDBDKPText = EDBFrame:CreateFontString("EDBLabel", "ARTWORK", "GameFontNormal");
		EDBDKPText:SetHeight(10);
		EDBDKPText:SetJustifyH("RIGHT");
		EDBDKPText:SetPoint("TOPLEFT", EDBFrame, "TOPLEFT", 0, -15);
		EDBDKPText:SetPoint("TOPRIGHT", EDBFrame, "TOPRIGHT", -10, -15);
	end
end

function Elgoh_CycleMS()
EDB[EDB.selected]["MS"]=EDB[EDB.selected]["MS"]-1;
if(EDB[EDB.selected]["MS"]<=0) then EDB[EDB.selected]["MS"]=3; end
EDB_UpdateLines(EDB.selected);
EDB_ToNote(EDB.selected);
end

function Elgoh_CycleOS()
EDB[EDB.selected]["OS"]=EDB[EDB.selected]["OS"]-1;
if(EDB[EDB.selected]["OS"]==0) then EDB[EDB.selected]["OS"]=3; end
EDB_UpdateLines(EDB.selected);
EDB_ToNote(EDB.selected);
end

function EDB_GuildFrameUpdated()
	local pname,rank= GetGuildRosterInfo(GetGuildRosterSelection());
	if pname then
		if pname == EDB.selected then return end
		EDB.selected = pname;
		EDB_Snapshot(pname);
		EDB_UpdateLines(pname,rank);
	end
end

local Roles={"Tank","Healer","DPS"};
function EDB_UpdateLines(who,rank)
	
	EDB_Snapshot(UnitName("PLAYER"));
	if(ElgohRankList[rank] and ElgohRankList[rank]["ignored"]==1) then EDBFrame:Hide(); return; else EDBFrame:Show(); end
	EDBDKPText:SetText("");
	local MSText="";
	local OSText="";
	if(EDB[who]) then
		MSText=Roles[EDB[who]["MS"]];
		OSText=Roles[EDB[who]["OS"]];
		EDBMSText:SetText("MS: "..MSText);
		EDBOSText:SetText("OS: "..OSText);
		--- DKP bit
		if(who~=playername) then
			if(EDB[playername] and EDB[playername]["priority"]~=nil) then
				if(EDB[who]["priority"]) then
					EDBDKPText:SetText("DKP: "..EDB[who]["priority"]);
					EDBDKPText:SetTextColor(0.2,1,0.2);
					if((EDB[playername]["earned"]>ElgohThreshhold and EDB[who]["earned"]>ElgohThreshhold) or (EDB[playername]["earned"]<ElgohThreshhold and EDB[who]["earned"]<ElgohThreshhold)) then
						if(EDB[who]["priority"]>EDB[playername]["priority"]) then
							EDBDKPText:SetText("DKP: "..EDB[who]["priority"]);
							EDBDKPText:SetTextColor(1,0.2,0.2);
						end
					elseif(EDB[playername]["earned"]<ElgohThreshhold and EDB[who]["earned"]>ElgohThreshhold) then
						EDBDKPText:SetText("DKP: "..EDB[who]["priority"]);
						EDBDKPText:SetTextColor(1,0.2,0.2);
					end
				end
			end
		else
			EDBDKPText:SetText("DKP: "..EDB[playername]["priority"]);
			EDBDKPText:SetTextColor(1,1,1);			
		end
	end
end

function EDB_LoadValues(who)
	for i = 1, GetNumGuildMembers(), 1 do 
		local name = GetGuildRosterInfo(i);
		if(who==nil or name==who) then
			if(GL_DKPValues["current_dkp_data"][name:lower()]~=nil) then
				EDB[name]["earned"]=GL_DKPValues["current_dkp_data"][name:lower()]["earned"];
				EDB[name]["spent"]=GL_DKPValues["current_dkp_data"][name:lower()]["spent"];
				EDB[name]["priority"]=GL_DKPValues["current_dkp_data"][name:lower()]["current"];
			end
		end
	end
end

function EDB_ToNote(who)
	for i = 1, GetNumGuildMembers(), 1 do 
		local name = GetGuildRosterInfo(i);
		if(who==nil or name==who) then
			local oNote=strjoin(":","$"..EDB[name]["MS"], EDB[name]["OS"], EDB[name]["earned"], EDB[name]["spent"], EDB[name]["priority"].."$");
			GuildRosterSetOfficerNote(i, oNote);
		end
	end
end

function EDB_Snapshot(who)
EDebug("Snapshotting "..who);
local complete=0;
	for i = 1, GetNumGuildMembers(), 1 do
		local name,_,_,_,_,_,_,officernote = GetGuildRosterInfo(i);
		if(name==who) then
			local EDBString=string.match(officernote, "$(.*)%$");
			if(EDBString==nil) then Elgoh_Print("Invalid DKP String found: Defaulting "..who); Elgoh_Default(who); return; end
			
			local MS,OS,Earned,Spent,Priority=strsplit(":",EDBString);
			MS=tonumber(MS);
			OS=tonumber(OS);
			Earned=tonumber(Earned);
			Spent=tonumber(Spent);
			Priority=tonumber(Priority);
			
			if(MS~=1 and MS~=2 and MS~=3) then Elgoh_Print("Invalid DKP String found: Defaulting "..who); Elgoh_Default(who); return; end
			if(Earned==nil or Spent==nil or Priority==nil) then Elgoh_Print("Invalid DKP String found: Defaulting "..who); Elgoh_Default(who); return; end
			
			EDB[who]={};
			EDB[who]["MS"]=MS;
			EDB[who]["OS"]=OS;
			EDB[who]["earned"]=Earned;
			EDB[who]["spent"]=Spent;
			EDB[who]["priority"]=Priority;
			return;
		end
	end
end

function Elgoh_Default(who)
	EDB[who]={};
	EDB[who]["MS"]=3;
	EDB[who]["OS"]=3;
	EDB[who]["earned"]=0;
	EDB[who]["spent"]=0;
	EDB[who]["priority"]=0;
	EDB_LoadValues(who);
	EDB_ToNote(who);
end